/*font routines by adok
  unoptimized, but who cares? i don't use these routines anymore anyway.. :)*/

unsigned int zseg,zoff8,zoff14,zoff16;  //offsets of the ROM fonts
char fntram[4096];                      //memory for own fonts.

void getfntram(void);
void loadfont(char *fntname,unsigned char fntheight);
void activatefont(unsigned char fntheight);

//save BIOS font offsets/segments in global variables
void getfont(void)
{
  unsigned int zo8,zo14,zo16,zs;

  asm {
    push bp
  //load 8x16-charset
    mov ax,0x1130
    mov bx,0x600
    int 0x10
    mov bx,bp
    pop bp
    mov word ptr zo16,bx
    mov word ptr zs,es

    push bp
  //load 8x14-charset
    mov ax,0x1130
    mov bx,0x200
    int 0x10
    mov bx,bp
    pop bp
    mov word ptr zo14,bx

    push bp
  //load 8x8-charset
    mov ax,0x1130
    mov bx,0x300
    int 0x10
    mov bx,bp
    pop bp
    mov word ptr zo8,bx
  }

  zseg=zs;
  zoff8=zo8;
  zoff14=zo14;
  zoff16=zo16;
}

void loadfont(char *fntname,unsigned char fntheight)
{
  unsigned int i;
  FILE *fntfile;

  if( ( fntfile=fopen(fntname,"rb") ) == NULL )
  {
    printf("font file could not be loaded\n");
    exit(1);
  }

  //save in buffer
  for(i=0;i<=fntheight*256-1;i++) fntram[i]=fgetc(fntfile);

  fclose(fntfile);
}

void activatefont(unsigned char fntheight)
{
  //store in bios font ram
  asm {
    push bp
    mov bh,fntheight
    xor bl,bl
    mov ax,seg fntram
    mov es,ax
    mov ax,offset fntram
    mov bp,ax
    mov cx,256
    xor dx,dx
    mov ax,0x1100
    int 0x10
    pop bp
  }
}